#ifndef _PICTOR_H
#define _PICTOR_H

#define PICTOR_IQIK_M_CAL_MAX	64
#define PICTOR_IQIK_M_CAL_MID	32

#include "standard.h"

typedef enum
{
	PICTOR_GAIN,		/*return PICTOR_LNA_GAIN, PICTOR_PGC_GAIN, PICTOR_PGA1_GAIN, and PICTOR_PGA2_GAIN*/
	PICTOR_LNA_GAIN,
	PICTOR_PGC_GAIN,
	PICTOR_PGA1_GAIN,
	PICTOR_PGA2_GAIN,
	PICTOR_RF_BACKOFF,
	PICTOR_BB_BACKOFF,
	PICTOR_DCC,		/*return PICTOR_DCC_I and PICTOR_DCC_Q*/
	PICTOR_DCC_I,
	PICTOR_DCC_Q,
	PICTOR_RF_GMAX,
	PICTOR_TOTAL_GMAX,
	PICTOR_P_INBAND_SHIFT,
	PICTOR_P_ALL,	/*return PICTOR_P_RSSI, PICTOR_P_TOTAL, and PICTOR_P_INBAND*/
} PICTOR_Param;

extern Demodulator* Afatech_PICTOR_demodulator;
extern Byte Afatech_PICTOR_chip;

unsigned long pictor_init(void);
unsigned long pictor_setfreq(unsigned int bw_kHz, unsigned int rf_freq_kHz);
unsigned long pictor_rmr(unsigned long mem_addr, unsigned char len, unsigned char *buf);
unsigned long pictor_wmr(unsigned long mem_addr, unsigned char len, unsigned char *val);

unsigned int pictor_get_cal_freq_iqik(unsigned int rf_freq_kHz, unsigned char iqik_m_cal);
unsigned int pictor_get_freq_code(unsigned int rf_freq_kHz, unsigned int *nc, unsigned int *nv, unsigned int *mv);
unsigned int pictor_get_nc(unsigned int rf_freq_kHz);
unsigned int pictor_get_nv(unsigned int nc);
unsigned char pictor_get_lna_cap_sel(unsigned int rf_freq_kHz);
unsigned int pictor_get_lo_freq(unsigned int rf_freq_kHz);
unsigned char pictor_get_lpf_bw(unsigned int bw_kHz);

unsigned long pictor_get_param(PICTOR_Param param, int *buf);
unsigned long pictor_set_param(PICTOR_Param param, int *val);

#endif